package net.saltymc.eaa.commands;

import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import net.fabricmc.fabric.api.client.command.v2.FabricClientCommandSource;
import net.minecraft.command.argument.EntityArgumentType;
import net.saltymc.eaa.function.CheckFunction;

import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.argument;
import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.literal;

public class CheckPlayerCommand extends EaaModCommand{

    @Override
    public int run(CommandContext<FabricClientCommandSource> context) {
        FabricClientCommandSource source = context.getSource();

        String player = StringArgumentType.getString(context,"player");

        CheckFunction.checkPlayer(player, source);

        return 1;
    }

    @Override
    public LiteralArgumentBuilder<FabricClientCommandSource> getCommandSpecification() {
        return literal("/check")
                .then(
                    argument("player", StringArgumentType.word())
                            .suggests((ctx, builder) -> EntityArgumentType.player().listSuggestions(ctx, builder))
                            .executes(this));
    }
}
